﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;
namespace MultiCheckBox
{
    public partial class Form1 : Form
    {
        FlexGridExt grid;
        IList<Row> selectedRowList;
        public Form1()
        {
            InitializeComponent();

            selectedRowList = new List<Row>();
            grid = new FlexGridExt();
            grid.Dock = DockStyle.Fill;
            Controls.Add(grid);

            DataTable dt = new DataTable();
            dt.Columns.Add("ID");
            dt.Columns.Add("Name");

            dt.Rows.Add(1, "A");
            dt.Rows.Add(2, "B");
            dt.Rows.Add(3, "C");
            dt.Rows.Add(4, "D");
            dt.Rows.Add(5, "E");
            dt.Rows.Add(6, "F");
            dt.Rows.Add(7, "G");
            dt.Rows.Add(8, "H");
            grid.DataSource = dt;
            grid.Cols.Insert(1);

            for (int row = 1; row < grid.Rows.Count; row++)
                grid.SetCellCheck(row, 1, CheckEnum.Unchecked);

            for (int col = 2; col < grid.Cols.Count; col++)
                grid.Cols[col].AllowEditing = false;

            grid.AfterEdit += Grid_AfterEdit;
        }

        private void Grid_AfterEdit(object sender, RowColEventArgs e)
        {
            for(int row = grid.Selection.r1; row <= grid.Selection.r2; row++)
            {
                if (grid.GetCellCheck(row, 1) == CheckEnum.Checked)
                {
                    if (!selectedRowList.Contains(grid.Rows[row]))
                        selectedRowList.Add(grid.Rows[row]);
                }
                else
                    selectedRowList.Remove(grid.Rows[row]);
            }
            Console.WriteLine("AfterEdit");
            //can access the selectedRowList to get the list of selected rows.
        }
    }
    public class FlexGridExt : C1FlexGrid
    {
        int checkedRow;
        private bool _flag;
        private int _firstChecked;
        private int _firstUnchecked;
        protected override void OnAfterEdit(RowColEventArgs e)
        {
            //"AfterEdit" event fires in a BottomUp approach for the selected range
            if (_flag)
            {
                if (this.GetCellCheck(e.Row, 1) == CheckEnum.Checked)
                    checkedRow = _firstUnchecked;
                else
                    checkedRow = _firstChecked;
                _flag = false;
            }
            if (e.Row != checkedRow)
                return;
            base.OnAfterEdit(e);
        }
        protected override void OnSelChange(EventArgs e)
        {
            base.OnSelChange(e);
            _flag = true;
            _firstChecked = GetFirstIndex(this.Selection, CheckEnum.Checked);
            _firstUnchecked = GetFirstIndex(this.Selection, CheckEnum.Unchecked);
        }
        private int GetFirstIndex(CellRange range,CheckEnum state)
        {
            if (range.r1 > 0)
            {
                for (int row = range.r1; row <= range.r2; row++)
                {
                    if (GetCellCheck(row, 1) == state)
                        return row;
                }
            }
            return 0;
        }
    }
}
